<script>
import {
  GlAvatar,
  GlButton,
  GlFormGroup,
  GlFormInput,
  GlSprintf,
  GlTooltipDirective as GlTooltip,
} from '@gitlab/ui';
import { mapState, mapActions, mapGetters } from 'vuex';
import { s__, __ } from '~/locale';
import AccessDropdown from '~/projects/settings/components/access_dropdown.vue';
import { ACCESS_LEVELS, DEPLOYER_RULE_KEY, APPROVER_RULE_KEY } from './constants';
import EditProtectedEnvironmentRulesCard from './edit_protected_environment_rules_card.vue';
import AddRuleModal from './add_rule_modal.vue';
import AddApprovers from './add_approvers.vue';
import ProtectedEnvironments from './protected_environments.vue';

export default {
  components: {
    GlAvatar,
    GlButton,
    GlFormGroup,
    GlFormInput,
    GlSprintf,
    AccessDropdown,
    ProtectedEnvironments,
    EditProtectedEnvironmentRulesCard,
    AddRuleModal,
    AddApprovers,
  },
  directives: {
    GlTooltip,
  },
  inject: { accessLevelsData: { default: [] } },
  data() {
    return { isAddingRule: false, addingEnvironment: null, addingRule: '' };
  },
  computed: {
    ...mapState(['projectId', 'loading', 'protectedEnvironments', 'editingRules']),
    ...mapGetters(['getUsersForRule']),
    isAddingDeploymentRule() {
      return this.addingRule === DEPLOYER_RULE_KEY;
    },
    addRuleModalTitle() {
      return this.isAddingDeploymentRule
        ? this.$options.i18n.addDeploymentRuleModalTitle
        : this.$options.i18n.addApprovalRuleModalTitle;
    },
  },
  mounted() {
    this.fetchProtectedEnvironments();
  },
  methods: {
    ...mapActions([
      'fetchProtectedEnvironments',
      'deleteRule',
      'setRule',
      'saveRule',
      'editRule',
      'updateRule',
    ]),
    canDeleteDeployerRules(env) {
      return env[DEPLOYER_RULE_KEY].length > 1;
    },
    addRule({ environment, ruleKey }) {
      this.addingEnvironment = environment;
      this.addingRule = ruleKey;
      this.isAddingRule = true;
    },
  },
  i18n: {
    title: s__(
      'ProtectedEnvironments|List of protected environments (%{protectedEnvironmentsCount})',
    ),
    deployersHeader: s__('ProtectedEnvironments|Allowed to deploy'),
    approversHeader: s__('ProtectedEnvironments|Allowed to approve'),
    approvalsHeader: s__('ProtectedEnvironments|Approvals required'),
    usersHeader: s__('ProtectedEnvironments|Users'),
    addDeployerText: s__('ProtectedEnvironments|Add deployment rules'),
    addApproverText: s__('ProtectedEnvironments|Add approval rules'),
    deployerDeleteButtonTitle: s__('ProtectedEnvironments|Delete deployer rule'),
    approverDeleteButtonTitle: s__('ProtectedEnvironments|Delete approver rule'),
    addDeploymentRuleModalTitle: s__('ProtectedEnvironments|Create deployment rule'),
    addApprovalRuleModalTitle: s__('ProtectedEnvironments|Create approval rule'),
    addModalText: __('Set a group, access level or users who are required to deploy.'),
    addDeployerLabel: s__('ProtectedEnvironments|Allowed to deploy'),
    editApproverButton: s__('ProtectedEnvironments|Edit'),
    saveApproverButton: s__('ProtectedEnvironments|Save'),
  },
  ACCESS_LEVELS,
  DEPLOYER_RULE_KEY,
  APPROVER_RULE_KEY,
};
</script>
<template>
  <div data-testid="protected-environments-list">
    <h5>
      <gl-sprintf :message="$options.i18n.title">
        <template #protectedEnvironmentsCount>{{ protectedEnvironments.length }}</template>
      </gl-sprintf>
    </h5>
    <add-rule-modal
      v-model="isAddingRule"
      :title="addRuleModalTitle"
      @saveRule="saveRule({ environment: addingEnvironment, ruleKey: addingRule })"
    >
      <template v-if="isAddingDeploymentRule" #add-rule-form>
        <p>{{ $options.i18n.addModalText }}</p>
        <gl-form-group :label="$options.i18n.addDeployerLabel" label-for="create-deployer-dropdown">
          <access-dropdown
            id="create-deployer-dropdown"
            class="gl-w-30p"
            :access-levels-data="accessLevelsData"
            :access-level="$options.ACCESS_LEVELS.DEPLOY"
            @hidden="setRule({ environment: addingEnvironment, newRules: $event })"
          />
        </gl-form-group>
      </template>
      <template v-else #add-rule-form>
        <add-approvers
          :project-id="projectId"
          @change="setRule({ environment: addingEnvironment, newRules: $event })"
        />
      </template>
    </add-rule-modal>
    <protected-environments :environments="protectedEnvironments">
      <template #default="{ environment }">
        <edit-protected-environment-rules-card
          :loading="loading"
          :add-button-text="$options.i18n.addDeployerText"
          :environment="environment"
          :rule-key="$options.DEPLOYER_RULE_KEY"
          :data-testid="`protected-environment-${environment.name}-deployers`"
          class="gl-rounded-top-base gl-border gl-border-b-initial"
          @addRule="addRule"
        >
          <template #card-header>
            <span class="gl-w-30p">{{ $options.i18n.deployersHeader }}</span>
            <span class="">{{ $options.i18n.usersHeader }}</span>
          </template>
          <template #rule="{ rule, ruleKey }">
            <span class="gl-w-30p" data-testid="rule-description">
              {{ rule.access_level_description }}
            </span>

            <gl-avatar
              v-for="user in getUsersForRule(rule, ruleKey)"
              :key="user.id"
              v-gl-tooltip
              :src="user.avatar_url"
              :title="user.name"
              :size="24"
              class="gl-mr-2"
            />

            <gl-button
              v-if="canDeleteDeployerRules(environment)"
              v-gl-tooltip
              category="secondary"
              variant="danger"
              icon="remove"
              :loading="loading"
              :title="$options.i18n.deployerDeleteButtonTitle"
              :aria-label="$options.i18n.deployerDeleteButtonTitle"
              class="gl-ml-auto"
              @click="deleteRule({ environment, rule, ruleKey })"
            />
          </template>
        </edit-protected-environment-rules-card>
        <edit-protected-environment-rules-card
          :loading="loading"
          :add-button-text="$options.i18n.addApproverText"
          :environment="environment"
          :rule-key="$options.APPROVER_RULE_KEY"
          :data-testid="`protected-environment-${environment.name}-approvers`"
          class="gl-rounded-bottom-left-base gl-rounded-bottom-right-base gl-border"
          @addRule="addRule"
        >
          <template #card-header>
            <span class="gl-w-30p">{{ $options.i18n.approversHeader }}</span>
            <span class="gl-w-20p">{{ $options.i18n.usersHeader }}</span>
            <span class="gl-w-30p">{{ $options.i18n.approvalsHeader }}</span>
          </template>
          <template #rule="{ rule, ruleKey }">
            <span class="gl-w-30p" data-testid="rule-description">
              {{ rule.access_level_description }}
            </span>

            <div class="gl-w-20p">
              <gl-avatar
                v-for="user in getUsersForRule(rule, ruleKey)"
                :key="user.id"
                v-gl-tooltip
                :src="user.avatar_url"
                :title="user.name"
                :size="32"
                class="gl-mr-2"
              />
            </div>

            <template v-if="editingRules[rule.id]">
              <gl-form-input
                v-model="editingRules[rule.id].required_approvals"
                class="gl-w-20p gl-text-center"
              />

              <gl-button
                class="gl-ml-auto gl-mr-4"
                @click="updateRule({ rule, environment, ruleKey })"
              >
                {{ $options.i18n.saveApproverButton }}
              </gl-button>
            </template>
            <template v-else>
              <span class="gl-w-20p gl-text-center">{{ rule.required_approvals }}</span>

              <gl-button class="gl-ml-auto gl-mr-4" @click="editRule(rule)">
                {{ $options.i18n.editApproverButton }}
              </gl-button>
            </template>

            <gl-button
              v-gl-tooltip
              category="secondary"
              variant="danger"
              icon="remove"
              :loading="loading"
              :title="$options.i18n.approverDeleteButtonTitle"
              :aria-label="$options.i18n.approverDeleteButtonTitle"
              @click="deleteRule({ environment, rule, ruleKey })"
            />
          </template>
        </edit-protected-environment-rules-card>
      </template>
    </protected-environments>
  </div>
</template>
